controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::class,
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::class,
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex() {
        return $this->render('index');
    }

    public function actionEjercicio1() {
        $alumnos = ['Mario', 'Ana', 'Maheva', 'Denis'];

        return $this->render('ejercicio1', [
            'alumnos' => $alumnos]);
    }

    public function actionEjercicio2a() {
        $fotos = ['a.jpg', 'b.jpg', 'c.jpg'];

        return $this->render('ejercicio2a', [
            'fotos' => $fotos]);
    }

    public function actionEjercicio2b() {
        $fotos = ['a.jpg', 'b.jpg', 'c.jpg'];

        return $this->render('ejercicio2b', [
            'fotos' => $fotos]);
    }

    public function actionEjercicio3(int $id = 0) {
        $alumnos = [
            [
                "nombre" => "Ana",
                "poblacion" => "Santoña",
                "imagen" => "a.jpg"
            ],
            [
                "nombre" => "Maheva",
                "poblacion" => "Santoña",
                "imagen" => "b.jpg",
            ],
            [
                "nombre" => "Alberto",
                "poblacion" => "Santoña",
                "imagen" => "c.jpg"
            ]
        ];

        $alumnoSinFoto = $alumnos[$id];
        unset($alumnoSinFoto['imagen']);

        return $this->render('ejercicio3', [
            'alumno' => $alumnos[$id],
            'alumnoSinFoto' => $alumnoSinFoto
        ]);
    }

    public function actionEjercicio4() {
        $numeros = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20];

        return $this->render('ejercicio4', [
            'numeros' => $numeros]);
    }
    
    public function actionEjercicio5() {
        $datos = [
            [
                "id" => 1,
                "nombre" => "Jorge",
                "poblacion" => "Santander",
                "direccion" => "Calle 1",
            ],
            [
                "id" => 2,
                "nombre" => "Ana",
                "poblacion" => "Santander",
                "direccion" => "Calle 2",
            ],
            [
                "id" => 3,
                "nombre" => "Maria",
                "poblacion" => "Santander",
                "direccion" => "Calle 3",
            ],
            [
                "id" => 4,
                "nombre" => "Carlos",
                "poblacion" => "Santander",
                "direccion" => "Calle 4",
            ]
        ];

        // Quiero que en la vista se muestre los datos anteriores utilizando CARDS
        // En el titulo de la CARD me coloca el id de cada elemento, en el texto de la card me coloca el nombre
        // Y el resto de los campos en una lista denetro de la CARD con el formato NomreCampo: Valor

        return $this->render('ejercicio5', [
            'datos' => $datos]);
    }

    public function actionEjercicio6() {
        $datos = [
            [
                "id" => 1,
                "nombre" => "Jorge",
                "poblacion" => "Santander",
                "direccion" => "Calle 1",
            ],
            [
                "id" => 2,
                "nombre" => "Ana",
                "poblacion" => "Santander",
                "direccion" => "Calle 2",
            ],
            [
                "id" => 3,
                "nombre" => "Maria",
                "poblacion" => "Santander",
                "direccion" => "Calle 3",
            ],
            [
                "id" => 4,
                "nombre" => "Carlos",
                "poblacion" => "Santander",
                "direccion" => "Calle 4",
            ]
        ];

        // Quiero que en la vista se muestre los datos anteriores utilizando CARDS
        // En el titulo de la CARD me coloca el id de cada elemento, en el texto de la card me coloca el nombre
        // Y el resto de los campos en una lista denetro de la CARD con el formato NomreCampo: Valor
        // Utilizando subvistas

        return $this->render('ejercicio6', [
            'datos' => $datos]);
    }
}

views/layouts/main.php
<?php

/** @var yii\web\View $this */
/** @var string $content */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap5\Breadcrumbs;
use yii\bootstrap5\Html;
use yii\bootstrap5\Nav;
use yii\bootstrap5\NavBar;

AppAsset::register($this);

$this->registerCsrfMetaTags();
$this->registerMetaTag(['charset' => Yii::$app->charset], 'charset');
$this->registerMetaTag(['name' => 'viewport', 'content' => 'width=device-width, initial-scale=1, shrink-to-fit=no']);
$this->registerMetaTag(['name' => 'description', 'content' => $this->params['meta_description'] ?? '']);
$this->registerMetaTag(['name' => 'keywords', 'content' => $this->params['meta_keywords'] ?? '']);
$this->registerLinkTag(['rel' => 'icon', 'type' => 'image/x-icon', 'href' => Yii::getAlias('@web/favicon.ico')]);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>

<header id="header">
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => ['class' => 'navbar-expand-md navbar-dark bg-dark fixed-top']
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav'],
        'items' => [
            ['label' => 'Home', 'url' => ['/site/index']],
            ['label' => 'Ejercicio1', 'url' => ['/site/ejercicio1']],
            ['label' => 'Ejercicio2', 'items' => [
                ['label' => 'Ejercicio2 - Foreach', 'url' => ['/site/ejercicio2a']],
                ['label' => 'Ejercicio2 - UL', 'url' => ['/site/ejercicio2b']],
            ]],
            ['label' => 'Ejercicio3', 'items' => [
                ['label' => 'Ejercicio3 - Alumno 1', 'url' => ['/site/ejercicio3', 'id' => 0]],
                ['label' => 'Ejercicio3 - Alumno 2', 'url' => ['/site/ejercicio3', 'id' => 1]],
                ['label' => 'Ejercicio3 - Alumno 3', 'url' => ['/site/ejercicio3', 'id' => 2]],
            ]],
            ['label' => 'Ejercicio4', 'url' => ['/site/ejercicio4']],
            ['label' => 'Ejercicio5', 'url' => ['/site/ejercicio5']],
            ['label' => 'Ejercicio6', 'url' => ['/site/ejercicio6']]
        ]
    ]);
    NavBar::end();
    ?>
</header>

<main id="main" class="flex-shrink-0" role="main">
    <div class="container">
        <?php if (!empty($this->params['breadcrumbs'])): ?>
            <?= Breadcrumbs::widget(['links' => $this->params['breadcrumbs']]) ?>
        <?php endif ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>

<footer id="footer" class="mt-auto py-3 bg-light">
    <div class="container">
        <div class="row text-muted">
            <div class="col-md-6 text-center text-md-start">&copy; My Company <?= date('Y') ?></div>
            <div class="col-md-6 text-center text-md-end"><?= Yii::powered() ?></div>
        </div>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>

views/site/Ejercicio2b.php
<?php
    use yii\helpers\Html;

    /** @var yii\web\View $this */

    $this->title = 'Ejercicio2b';
?>

<div class="row">
    <h1>Ejercicio2 - UL</h1>

    <div class="row">
        <?php
            echo Html::ul($fotos, [
                'class' => 'list-group list-group-horizontal',
                'item' => function ($foto) {
                    return 
                        Html::tag('li', 
                            Html::img("@web/imgs/{$foto}", [
                                "alt" => $foto,
                                "class" => "img-thumbnail col-md-3",
                                "style" => "width: 400px; height: 400px;",
                            ]),
                        ['class' => 'list-group-item']);
                }
            ]);
        ?>
    </div>
</div>

views/site/_ejercicio6.php
<?php
    use yii\helpers\Html;
?>

<?= Html::ul($dato, [
    'class' => 'list-group list-group-flush', 
    "item" => function ($dato2, $indice) {
        if ($indice == "poblacion" || $indice == "direccion") {
            return "<li class='list-group-item list-group-item-action'>{$indice}: {$dato2} </li>";
        }
    }
]) ?>
            

views/site/_elemento.php
<li class="list-group-item list-group-item-action"><?= $numero ?></li>

views/site/_listado.php
<ul class="list-group list-group-horizontal">
    <?php 
        foreach ($numeros as $numero) { 
            echo $this->render('_elemento', [
                'numero' => $numero
            ]);
        } 
    ?>
</ul>

views/site/ejercicio1.php
<?php
    use yii\helpers\Html;

    /** @var yii\web\View $this */

    $this->title = 'Ejercicio1';
?>

<div class="row">
    <h1>Ejercicio1</h1>
    
    <h5 class="text-center my-3">Con foreach</h5>

    <div class="row">
        <div class="col-12 d-flex justify-content-center">
            <ul class="list-group text-center w-25">
                <?php foreach ($alumnos as $alumno) { ?>
                    <li class="list-group-item"><?= $alumno ?></li>
                <?php } ?>
            </ul>
        </div>
    </div>

    <h5 class="text-center my-3">Con el helper HTML de YII2</h5>

    <div class="row">
        <div class="col-12 d-flex justify-content-center">
            <?= Html::ul($alumnos, [
                'class' => 'list-group text-center w-25', 
                'itemOptions' => 
                    ['class' => 'list-group-item']
                ]) 
            ?>
        </div>
    </div>
</div>

views/site/ejercicio2a.php
<?php
    use yii\helpers\Html;

    /** @var yii\web\View $this */

    $this->title = 'Ejercicio2a';
?>

<div class="row">
    <h1>Ejercicio2 - FOREACH CON VISTA</h1>

    <div class="row">
        <?php foreach ($fotos as $foto) { ?>
            <div class="card-group col-md-4 mb-4">
                <div class="card">
                    <div class="card-header">
                        <?= Html::img(
                            "@web/imgs/{$foto}", [
                            "alt' => '{$foto}'", 
                            'class' => 'card-img-top col-sm-6',
                            ]) 
                        ?>
                    </div>
                    <div class="card-body text-center">
                        <h4 class="card-title font-italic text-primary">FOTO</h4>
                        <p class="card-text lead text-muted"><?= $foto ?></p>
                    </div>
                </div>
            </div>
        <?php } ?>
    </div>
</div>

views/site/ejercicio3.php
<?php
    use yii\helpers\Html;

    /** @var yii\web\View $this */

    $this->title = 'Ejercicio3';
?>

<div class="row">
    <h1 class="text-center">Ejercicio3</h1>

    <div class="row mt-3">
        <div class="card col-md-6 mb-4 mx-auto">
            <div class="card-header">
                <?= Html::img(
                    "@web/imgs/{$alumno['imagen']}", [
                    'alt' => $alumno['imagen'], 
                    'class' => 'card-img-top col-sm-6 mx-auto',
                    ]) 
                ?>
            </div>
            <?= Html::ul($alumno, [
                'class' => 'list-group list-group-flush text-center', 
                // 'itemOptions' => 
                //     ['class' => 'list-group-item list-group-item-action']
                "item" => function ($datoAlumno, $indice) {
                        $salida = "";
                        
                        if ($indice != "imagen") {
                            $salida .= "<li class='list-group-item list-group-item-action'> {$datoAlumno} </li>";
                        }

                        return $salida;
                    }
                ]) 
            ?>
        </div>
    </div>
</div>

views/site/ejercicio4.php
<?php
    use yii\helpers\Html;

    /** @var yii\web\View $this */

    $this->title = 'Ejercicio4';
?>

<div class="row">
    <h1>Ejercicio4</h1>

    <h5 class="col-12 text-center my-4">Con Foreach y Vistas</h5>

    <div class="row">
        <div class="col-12 d-flex justify-content-center">
            <?php
                echo $this->render('_listado', [
                    'numeros' => $numeros
                ]);
            ?>
        </div>
    </div>
</div>

<div class="row">
    <h5 class="col-12 text-center my-4">Con el helper HTML y sin vistas</h5>

    <div class="row">
        <div class="col-12 d-flex justify-content-center">
            <?= 
                Html::ul($numeros, [
                'class' => 'list-group list-group-horizontal', 
                'itemOptions' => 
                    ['class' => 'list-group-item list-group-item-action']
                ]) 
            ?>
        </div>
    </div>

views/site/ejercicio5.php
<?php
    use yii\helpers\Html;

    /** @var yii\web\View $this */

    $this->title = 'Ejercicio5';
?>

<div class="row">
    <h1>Ejercicio5</h1>
    
    <div class="row my-3">
        <?php foreach ($datos as $dato) { ?>
            <div class="col-sm-4 my-3 mb-sm-0">
                <div class="card text-center">
                    <div class="card-header">
                        Alumnos
                    </div>

                    <div class="card-body">
                        <h4 class="card-title font-italic text-primary"><?= $dato['id'] ?> </h4>
                        <p class="card-text lead text-muted"><?= $dato['nombre'] ?></p>

                        <?= Html::ul($dato, [
                            'class' => 'list-group list-group-flush', 
                            "item" => function ($dato2, $indice) {
                                if ($indice == "poblacion" || $indice == "direccion") {
                                    return "<li class='list-group-item list-group-item-action'>{$indice}: {$dato2} </li>";
                                }
                            }
                        ]) ?>
                    </div>
                </div>
            </div>
        <?php } ?>
    </div>
</div>

views/site/ejercicio6.php
<?php
    use yii\helpers\Html;

    /** @var yii\web\View $this */

    $this->title = 'Ejercicio6';
?>

<div class="row">
    <h1>Ejercicio6</h1>
    
    <div class="row my-3">
        <?php foreach ($datos as $dato) { ?>
            <div class="col-sm-4 my-3 mb-sm-0">
                <div class="card text-center">
                    <div class="card-header">
                        Alumnos
                    </div>

                    <div class="card-body">
                        <h4 class="card-title font-italic text-primary"><?= $dato['id'] ?></h4>
                        <p class="card-text lead text-muted"><?= $dato['nombre'] ?></p>
                        <?=
                            $this->render('_ejercicio6', [
                                'dato' => $dato
                            ]);
                        ?>
                    </div>
                </div>
            </div>
        <?php } ?>
    </div>
</div>

views/site/error.php
<?php

/** @var yii\web\View $this */
/** @var string $name */
/** @var string $message */
/** @var Exception$exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

/** @var yii\web\View $this */

$this->title = 'Operaciones';

?>

<h1>Index</h1>

<div class="row">
    <p class="lead">La programación orientada a objetos (POO, en español) es un paradigma de programación que parte del concepto de "objetos" como base, los cuales contienen información en forma de campos (a veces también referidos como atributos o propiedades) y código en forma de métodos.
    Los objetos son capaces de interactuar y modificar los valores contenidos en sus campos o atributos (estado) a través de sus métodos (comportamiento).1​
    Muchos de los objetos prediseñados de los lenguajes de programación actuales permiten la agrupación en bibliotecas o librerías, sin embargo, muchos de estos lenguajes permiten al usuario la creación de sus propias bibliotecas.
    Algunas características clave de la programación orientada a objetos son herencia, cohesión, abstracción, polimorfismo, acoplamiento y encapsulamiento.
    Su uso se popularizó a principios de la década de 1990. En la actualidad, existe una gran variedad de lenguajes de programación 
    que soportan la orientación a objetos, estando la mayoría de éstos basados en el concepto de clases e instancias.</p>
</div>